package main

import (
	"fmt"
	"my/schet/pkg/input/conf"
	"my/schet/pkg/input/txt"
	"my/schet/pkg/output/cli"
	"my/schet/pkg/schet"
	"os"
)

const (
	Год = 2024
)

func main() {
	g := schet.NewГод(Год)

	err := загрузитьКонфиг(g)
	if err != nil {
		return
	}

	err = загрузитьДоходы(g)
	if err != nil {
		return
	}

	вывестиГод(g)
}

func загрузитьКонфиг(g *schet.Год) error {
	config_path := os.Args[1]
	c := conf.NewConf(config_path)
	err := c.Загрузить(g)
	if err != nil {
		fmt.Printf("Загрузка конфига: %v\n", err)
	}
	return err
}

func загрузитьДоходы(g *schet.Год) error {
	config_path := os.Args[2]
	c := txt.NewTXT(config_path)
	err := c.СчитатьиЗагрузитьвГод(g)
	if err != nil {
		fmt.Printf("СчитатьиЗагрузитьвГод: %v\n", err)
	}
	return err
}

func вывестиГод(g *schet.Год) {
	output := cli.NewCLI()
	g.Вывести(output)
}
