package schet

import (
	"errors"
)

const (
	ЦельОПС = "ОПС"
	Цель1пр = "1пр"
	ЦельУСН = "УСН"

	КБК_ОПС                = "18210202000011000160"
	КогдаСделать_ОПС       = "до конца квартала"
	СрокУплаты_ОПС_префикс = "9.01."
)

var (
	ErrНеизвестныйКвартал = errors.New("неизвестный квартал")
	ErrНеизвестнаяЦель    = errors.New("неизвестная цель")
)

type Цели struct {
	год      *Год
	Кварталы []*Квартал
}

func NewЦели(год *Год) *Цели {
	c := &Цели{
		год: год,
	}
	return c
}

func (c *Цели) Квартал(in int) (k *Квартал, e error) {
	e = ErrНеизвестныйКвартал

	if in < НомерПервогоКвартала || in > НомерПоследнегоКвартала {
		return
	}

	index := in - 1
	k = c.Кварталы[index]
	e = nil
	return
}
